<?
/*******************************************************************************
*    WMail 1.0. Webmail for PHP                                                *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

require_once('auth.inc.php');
require_once('session.inc.php');
require_once('maillist.inc.php');
require_once('attribute.inc.php');

$maillist = new Table('maillist', "main.php?sid=".session_id()."&maillist_class=Maillist", true, false, false);
$maillist->addHeader('&nbsp;');
if($viewSent == 'true')
  $maillist->addHeader(_('Empf&auml;nger'));
else
  $maillist->addHeader(_('Absender'));
$maillist->addHeader(_('Betreff'));
$maillist->addHeader(_('Datum'));
$maillist->addHeader(_('Gr&ouml;&szlig;e'));
$auth = $session[auth_data];

if(count($auth->getAliases()) == 0)
{
  header("LOCATION: prefs.php?sid=".session_id());
  exit();
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title><? echo _('WMail: ein Webmail f&uuml;r PHP'); ?></title>
<meta content='width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0' name='viewport' />
<meta name="viewport" content="width=device-width" />
<link href="/images/default.css" rel="stylesheet" type="text/css">
<link href="/images/mobile.css" media='all and (max-width: 839px)' rel="stylesheet" type="text/css"  />
<link rel="shortcut icon" href="/images/wmlogo.ico" >
<script type="text/javascript">
function setAllCheckBoxes(FormName, FieldName)
{
  if(!document.forms[FormName])
    return;
  var objCheckBoxes = document.forms[FormName].elements[FieldName];
  if(!objCheckBoxes)
    return;
  var countCheckBoxes = objCheckBoxes.length;
  if(!countCheckBoxes)
    if(document.forms[FormName].selectAction.value == 1)
      objCheckBoxes.checked = true;
    else
      objCheckBoxes.checked = false;
  else
    for(var i = 0; i < countCheckBoxes; i++)
      if(document.forms[FormName].selectAction.value == 1)
        objCheckBoxes[i].checked = true;
      else
        objCheckBoxes[i].checked = false;

  document.forms[FormName].selectAction.value = 1 - document.forms[FormName].selectAction.value;
}

function isSelected(FormName, FieldName)
{
  if(!document.forms[FormName])
    return(false);
  var objCheckBoxes = document.forms[FormName].elements[FieldName];
  if(!objCheckBoxes)
    return(false);
  var countCheckBoxes = objCheckBoxes.length;
  var isSel = false;
  if(isNaN(countCheckBoxes))
  {
    if(objCheckBoxes.checked)
      isSel = true;
  }
  else
  {
    for(var i = 0; i < countCheckBoxes; i++)
    {
      if(objCheckBoxes[i].checked)
          isSel = true;
    }
  }

  return(isSel);
}
</script>
</head>
<body>
<?
if($deleteSelected)
{
  if(is_array($mail))
  {
    dbConnect();
    $curAcc = getCurAcc($auth, $setMailbox);
    $pop3 =& new Net_POP3();
    $pop3->connect($curAcc['POP3'], 110);
    $pop3->login($curAcc['POP3-User'], $curAcc['POP3-Pwd']);
    foreach($mail as $m)
    {
      $pop3->deleteMsg($m);
      dbQuery("DELETE FROM indexes WHERE account = '".$curAcc['POP3-User']."' AND tmsg = $m");
      dbQuery("UPDATE indexes SET nmsg = nmsg - 1, tmsg = tmsg - 1 WHERE account = '".$curAcc['POP3-User']."' AND tmsg > $m AND sent = '$isSent';");
      dbQuery("UPDATE indexes SET tmsg = tmsg - 1 WHERE account = '".$curAcc['POP3-User']."' AND tmsg > $m AND sent != '$isSent';");
    }
    $pop3->disconnect();
    dbDisconnect();
  }
}

if($markEMail)
{
  if(is_array($mail))
  {
    dbConnect();
    $curAcc = getCurAcc($auth, $setMailbox);
    foreach($mail as $m)
    {
      if($markEMail == 'read')
        dbQuery("UPDATE indexes SET sread = 't' WHERE account = '".$curAcc['POP3-User']."' AND tmsg = $m;");
      if($markEMail == 'unread')
        dbQuery("UPDATE indexes SET sread = 'f' WHERE account = '".$curAcc['POP3-User']."' AND tmsg = $m;");
    }
    dbDisconnect();
  }
}

include_once 'menu.inc.php';
include_once 'mailboxes.inc.php';
include_once 'mailbox.inc.php';

if($mbs[$curAcc['Name'].'_nMsg'] != 0)
{
  dbConnect();
  $dateFormat = getAttribute('DATEFORMAT', '%D.%M.%Y %H:%I.%S');
  $sentMails = array();
  $res = dbQuery("SELECT id FROM indexes WHERE account = '".$curAcc['POP3-User']."' AND sent = 't' ORDER BY tmsg");
  while($idx = dbFetchArray($res))
    array_push($sentMails, $idx[0]);
  $idxs = array();
  $res = dbQuery("SELECT id, sread FROM indexes WHERE account = '".$curAcc['POP3-User']."' ORDER BY tmsg");
  while($idx = dbFetchArray($res))
    $idxs[$idx[0]] = $idx[1];
  dbDisconnect();
  for($l = 1; $l <= $mbs[$curAcc['Name'].'_nMsg']; $l++)
  {
    foreach(array_keys($mbs[$curAcc['Name'].'_header_'.$l]) as $h)
    {
      if(strtoupper($h) == 'FROM')
        $p1 = $mbs[$curAcc['Name'].'_header_'.$l][$h];
      if(strtoupper($h) == 'DELIVERY-DATE')
        $p2 = $mbs[$curAcc['Name'].'_header_'.$l][$h];
    }
    $p1 = str_replace('\\', '', $p1);
    $msgId = $p1.'_'.$p2;

    $fromAddr = $mbs[$curAcc['Name'].'_header_'.$l]['From'];
    if(strpos($fromAddr, '<') != 0)
      $fromAddr = substr($fromAddr, 0, strpos($fromAddr, '<') - 1);
    $toAddr = $mbs[$curAcc['Name'].'_header_'.$l]['To'];
    if(!is_array($toAddr))
      if(strpos($toAddr, '<') != 0)
        $toAddr = substr($toAddr, 0, strpos($toAddr, '<') - 1);
    $subj = $mbs[$curAcc['Name'].'_header_'.$l]['Subject'];
    $date = getEMailDate($mbs[$curAcc['Name'].'_header_'.$l]['Date']);
    $size = $mbs[$curAcc['Name'].'_size_'.$l];
    if($size > 1048576)
      $sizeStr    = round($size / 1048576, 2)." Mb";
    else
      if($size > 1024)
        $sizeStr    = round($size / 1024, 2)." Kb";
      else
        $sizeStr    = "$size bytes";
    if($viewSent == 'true')
    {
      if(in_array($msgId, $sentMails))
        $maillist->addLine(new Maillist($l, decodeHeader($toAddr), decodeHeader($subj), $date, $sizeStr, 't', 't', $mbs[$curAcc['Name'].'_header_'.$l]['X-Priority'], $mbs[$curAcc['Name'].'_hasAttachments_'.$l]));
    }
    else
    {
      if(!in_array($msgId, $sentMails))
        $maillist->addLine(new Maillist($l, decodeHeader($fromAddr), decodeHeader($subj), $date, $sizeStr, $idxs[$msgId], 'f', $mbs[$curAcc['Name'].'_header_'.$l]['X-Priority'], $mbs[$curAcc['Name'].'_hasAttachments_'.$l]));
    }
  }
}
?>
<form name="mlist" method="post" action="main.php?sid=<? print session_id(); ?>&setMailbox=<? print $curAcc['Name']; ?>&viewSent=<? echo $viewSent; ?>">
<div id="mailList" class="mailList">
  <table width="100%" cellpadding="0" cellspacing="0">
    <tr>
<?
if(count($maillist->lines) == 0)
{
?>
      <td class="mailList" width="100%" align="center"><i><h3><? echo _('Sie haben zur Zeit keine E-Mail'); ?></h3></i></td>
<?
}
else
{
  echo "<td class=\"mailList\" width=\"100%\" align=\"center\" style=\"border-bottom-width:1px;border-bottom-style:solid;border-right-width:1px;border-right-style:solid;\">\n";
  $maillist->displayTable('100%', 0, 0, array('23', '141', '241', '50', '50'), 0, 2, 'maillist');
  echo "</td>\n";
}
?>
    </tr>
    <tr>
      <td style="height:8px" width="100%"></td>
    </tr>
  </table>
<?
if(count($maillist->lines) != 0)
{
?>
  <table width="100%" cellpadding="0" cellspacing="0">
    <tr>
      <td class="mailbox" width="100%">
        <a href="#" class="mailmenu" onClick="setAllCheckBoxes('mlist', 'mail[]'); return false;"><b><? echo _('Alle aus-/abw&auml;hlen'); ?></b></a>
        <span class="mailmenu_separator">&nbsp;|&nbsp;</span>
        <span class="mailmenu_separator2"><br></span>
        <a href="#" class="mailmenu" onClick="if(isSelected('mlist', 'mail[]')) document.mlist.submit(); return false;"><b><? echo _('Ausgew&auml;hlte E-Mail l&ouml;schen'); ?></b></a>
<?
  if($viewSent != 'true')
  {
?>
        <span class="mailmenu_separator">&nbsp;|&nbsp;</span>
        <span class="mailmenu_separator2"><br></span>
        <a href="#" class="mailmenu" onClick="if(isSelected('mlist', 'mail[]')) {document.mlist.deleteSelected.value = ''; document.mlist.markEMail.value = 'unread'; document.mlist.submit();} return false;"><b><? echo _('Ausgew&auml;hlte E-Mail als ungelesen markieren'); ?></b></a>
        <span class="mailmenu_separator">&nbsp;|&nbsp;</span>
        <span class="mailmenu_separator2"><br></span>
        <a href="#" class="mailmenu" onClick="if(isSelected('mlist', 'mail[]')) {document.mlist.deleteSelected.value = ''; document.mlist.markEMail.value = 'read'; document.mlist.submit();} return false;"><b><? echo _('Ausgew&auml;hlte E-Mail als gelesen markieren'); ?></b></a>
<?
  }
?>
      </td>
    </tr>
  </table>
<?
}
?>
</div>
<input type="hidden" name="selectAction" value="1">
<input type="hidden" name="deleteSelected" value="true">
<input type="hidden" name="markEMail" value="">
</form>
</body>
</html>
