<?
/*******************************************************************************
*    WMail 1.0. Webmail for PHP                                                *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

class BaseList
{
  var $id;
  var $className;
  var $errorForm;

  function BaseList($id)
  {
    $this->id = $id;
    $this->className = 'BaseList';
  }

  function checkDataForm($formName, $tClass)
  {
    return true;
  }

  function checkDataFormDelete($formName, $tClass, $id)
  {
    return true;
  }

  function setDataForm($formName, $tClass)
  {
  }

  function display($startTemplate, $endTemplate, $widths = array())
  {
    print "$startTemplate&nbsp;$endTemplate\n";
  }

  function id()
  {
    return $this->id;
  }

  function className()
  {
    return $this->className;
  }

  function getFields()
  {
    return array();
  }

  function fields()
  {
    return null;
  }

  function displayFieldsForEdit($formName, $field, $selected)
  {
    print "<INPUT TYPE=\"TEXT\" NAME=\"$formName"."_field_$field\" VALUE=\"\">";
  }

  function displayFormError()
  {
    global $aliasError;

    $aliasError = $this->errorForm;
  }

  function sortCmpUp($first, $second)
  {
    return 0;
  }

  function sortCmpDwn($first, $second)
  {
    return 0;
  }
}

class Table
{
  var $formName, $formAction;
  var $headers, $lines;
  var $displayHeaders, $modifyFlag, $deleteFlag, $sortFlag;
  var $newedit, $editid, $errors, $sortStyle;
  var $sortArrowUp, $sortArrowDown, $defSortField, $actualSortField, $actualSortOrder;

  var $TABLELINK = 0;
  var $TABLESUBMIT = 1;
  var $TABLEIMAGE = 2;

  function Table($formName, $formAction, $displayHeaders = true, $modifyFlag = true, $deleteFlag = true, $sortFlag = false, $sortArrowUp = '', $sortArrowDown = '', $defSortField = '', $sortStyle = '')
  {
    $this->formName = $formName;
    $this->formAction = $formAction;
    $this->displayHeaders = $displayHeaders;
    $this->modifyFlag = $modifyFlag;
    $this->deleteFlag = $deleteFlag;
    $this->sortFlag = $sortFlag;
    $this->sortStyle = $sortStyle;
    $this->sortArrowUp = $sortArrowUp;
    $this->sortArrowDown = $sortArrowDown;
    $this->defSortField = $defSortField;
    $this->actualSortField = $defSortField;
    $this->actualSortOrder = 'DWN';
    $this->headers = array();
    $this->lines = array();
    $this->sid = '';
    $newedit = 0;
    $editid = -1;
  }

  function loadFromDBSession($sid)
  {
    $this->lines = array();
    $dbvalues = dbQuery("SELECT value FROM session WHERE sessionid = '$sid' AND name = 'table_".$this->formName."' ORDER BY sorder;");
    if($dbvalues)
    {
      while($val = dbFetchArray($dbvalues))
      {
        $line = unserialize($val[0]);
        $this->addLine($line);
      }
    }
  }

  function saveToDBSession($sid)
  {
    $res = dbQuery("DELETE FROM session WHERE sessionid = '$sid' AND name = 'table_".$this->formName."'");
    for($l = 0; $l < count($this->lines); $l++)
    {
      $line = $this->lines[$l];
      $res = dbQuery("INSERT INTO session(sessionid, name, value, sorder) VALUES ('$sid', 'table_".$this->formName."', '".dbEscape(serialize($line))."', $l)");
    }
  }

  function deleteFromDBSession($sid)
  {
    dbQuery("DELETE FROM session WHERE sessionid = '$sid' AND name = 'table_".$this->formName."'");
  }

  function addHeader($name)
  {
    $this->headers[] = $name;
  }

  function addLine($line)
  {
    $this->lines[] = $line;
  }

  function deleteLines()
  {
    $this->lines = array();
  }

  function hasToWork()
  {
    if(substr(@$_REQUEST['inc_table_'.$this->formName.'_action'], 0, strlen($this->formName)) == $this->formName && $_REQUEST[$this->formName.'_submit'] != '')
      return true;
    if($_REQUEST['inc_table_'.$this->formName.'_action'] == $this->formName.'_change')
      return true;
    if($_REQUEST['inc_table_'.$this->formName.'_action'] == $this->formName.'_delete')
      return true;
    foreach(array_keys($_REQUEST) as $key)
      if(substr($key, 0, strlen($this->formName.'_ts')) == $this->formName.'_ts')
        return true;
    if(substr($_REQUEST[$this->formName.'_ts'], 0, 4) == 'true')
      return true;
    return false;
  }

  function manage()
  {
    $this->newedit = 0;
    $this->errors = false;
    $this->modified = true;

    $byForm = 'false';
    foreach(array_keys($_REQUEST) as $key)
      if(substr($key, 0, strlen($this->formName.'_ts')) == $this->formName.'_ts' && substr($key, strlen($key) - 2) == '_y')
      {
        $byForm = 'true';
        $key = str_replace($this->formName.'_', 'form_', $key);
        parse_str(substr($key, 0, strlen($key) - 2));
      }

    if(($_REQUEST['inc_table_'.$this->formName.'_action'] == $this->formName.'_new' && $byForm == 'false') || $inc_table_form_action == 'form_new')
      {
        if($form_class == '')
          $class = $_REQUEST[$this->formName.'_class'];
        else
          $class = $form_class;
        $id = 0;
        foreach($this->lines as $line)
          if($line->id() > $id)
            $id = $line->id();
        $f = new $class($id + 1);
        if($f->checkDataForm($this->formName, $this))
          {
            $f->setDataForm($this->formName, $this);
            $this->addLine($f);
          }
        else
          {
            $f->displayFormError();
            $this->errors = true;
          }
        $this->newedit = 0;
      }
    if(($_REQUEST['inc_table_'.$this->formName.'_action'] == $this->formName.'_edit' && $byForm == 'false') || $inc_table_form_action == 'form_edit')
      {
        $this->newedit = 1;
        if($form_id == '')
          $searchId = $_REQUEST[$this->formName.'_field_id'];
        else
          $searchId = $form_id;
        foreach($this->lines as $l)
          if($l->id() == $searchId)
            $line = $l;
        if($line->checkDataForm($this->formName, $this))
          {
            $line->setDataForm($this->formName, $this);
            $nLines = array();
            foreach($this->lines as $l)
              if($l->id() != $line->id())
                $nLines[] = $l;
              else
                $nLines[] = $line;
            $this->lines = $nLines;
          }
        else
          {
            $line->displayFormError();
            $this->errors = true;
          }
        $this->newedit = 0;
      }
    if(($_REQUEST['inc_table_'.$this->formName.'_action'] == $this->formName.'_change' && $byForm == 'false') || $inc_table_form_action == 'form_change')
      {
        $this->newedit = 1;
        if($form_id != '')
          $this->editid = $form_id;
        else
          $this->editid = $_REQUEST[$this->formName.'_id'];
      }
    if(($_REQUEST['inc_table_'.$this->formName.'_action'] == $this->formName.'_delete' && $byForm == 'false') || $inc_table_form_action == 'form_delete')
      {
        if($form_id != '')
        {
          $f = new $form_class($form_id);
          $id = $form_id;
        }
        else
        {
          $class = $_REQUEST[$this->formName.'_class'];
          $f = new $class($_REQUEST[$this->formName.'_id']);
          $id = $_REQUEST[$this->formName.'_id'];
        }
        if($f->checkDataFormDelete($this->formName, $this, $id))
          {
            $nLines = array();
            for($l = 0; $l < count($this->lines); $l++)
              {
                $line = $this->lines[$l];
                if($line->id() != $id)
                  $nLines[] = $line;
              }
            $this->lines = $nLines;
            $this->newedit = 0;
          }
        else
          {
            $f->displayFormError();
            $this->errors = true;
          }
      }
    if(($_REQUEST['inc_table_'.$this->formName.'_action'] == $this->formName.'_sort' && $byForm == 'false') || $inc_table_form_action == 'form_sort')
      {
        $this->modified = false;
      }
    $this->actualSortField = $_REQUEST[$this->formName.'_sort_field'];
    $this->actualSortOrder = $_REQUEST[$this->formName.'_sort_order'];
  }

  function displaySortFields($width = '100%', $border = 1, $newForm = 1, $widths = array(), $cellspacing = 1, $cellpadding = 2)
  {
    if(strpos($this->formAction, '?') === false)
      $sep = '?';
    else
      $sep = '&';
?>
<TABLE WIDTH="<? print $width; ?>" BORDER="<? print $border; ?>" cellspacing="<? print $cellspacing; ?>" cellpadding="<? print $cellpadding; ?>">
<?
    if($this->sortFlag)
      {
        print "<TR>\n";
        for($l = 0; $l < count($this->headers); $l++)
        {
          if(count($widths) != 0)
            $widthTag = "WIDTH=\"$widths[$l]\"";
          if($this->actualSortField == $this->headers[$l])
            {
              if($this->actualSortOrder == 'UP')
                $sort = 'DWN';
              else
                $sort = 'UP';
            }
          else
            $sort = 'DWN';
          print "<TH $widthTag ".$this->sortStyle."><A HREF=\"".$this->formAction.$sep."inc_table_".$this->formName."_action=".$this->formName."_sort&".$this->formName."_sort_field=".$this->headers[$l]."&".$this->formName."_sort_order=$sort\">".($this->headers[$l]);
          if($this->sortArrowUp != '' && $this->sortArrowDown != '')
          {
            if($this->actualSortField == $this->headers[$l])
              if($this->actualSortOrder == 'UP')
                print $this->sortArrowUp;
              else
                print $this->sortArrowDown;
          }
          print "</A></TH>";
        }
        if($this->modifyFlag || $this->deleteFlag)
        {
          if(count($widths) != 0)
            $widthTag = "WIDTH=\"".$widths[count($widths) - 1]."\"";
          print "<TH $widthTag ".$this->sortStyle.">&nbsp;</TH>\n";
        }
        print "</TR>\n";

        $sortLink = "&".$this->formName."_sort_field=".$this->actualSortField."&".$this->formName."_sort_order=".$this->actualSortOrder;

        if(count($this->lines) > 0)
        {
          if($this->actualSortOrder == 'UP')
            usort($this->lines, array($this->lines[0]->className(), "sortCmpUp_$this->actualSortField"));
          else
            usort($this->lines, array($this->lines[0]->className(), "sortCmpDwn_$this->actualSortField"));
        }
      }
    else
      $sortLink = '';
?>
</TABLE>
<?
  }

  function displayTable($width = '100%', $border = 1, $newForm = 1, $widths = array(), $cellspacing = 1, $cellpadding = 2, $classHeader = '', $changeText = '', $deleteText = '', $alignChangeDelete = 'CENTER', $changeDeleteType = '')
  {
    if($changeDeleteType == '')
      $changeDeleteType = $this->TABLELINK;
    if($changeText == '')
      $changeText = _('&Auml;ndern');
    if($deleteText == '')
      $deleteText = _('L&ouml;schen');
    if(strpos($this->formAction, '?') === false)
      $sep = '?';
    else
      $sep = '&';
    if($newForm == 1)
      {
?>
<FORM NAME="<? print $this->formName; ?>_display" ACTION="<? print $this->formAction; ?>" METHOD="POST">
<?
      }
?>
<TABLE WIDTH="<? print $width; ?>" BORDER="<? print $border; ?>" cellspacing="<? print $cellspacing; ?>" cellpadding="<? print $cellpadding; ?>">
<?
    if($this->displayHeaders)
      {
        print "<TR>\n";
        if($classHeader != '')
          $headerC = " class=\"$classHeader\"";
        for($l = 0; $l < count($this->headers); $l++)
          print "<TH$headerC ID=\"TH_".$l."\">".$this->headers[$l]."</TH>";
        if($this->modifyFlag || $this->deleteFlag)
          print "<TH$headerC>&nbsp;</TH>\n";
        print "</TR>\n";
      }
    if($this->sortFlag)
      {
        $sortLink = "&".$this->formName."_sort_field=".$this->actualSortField."&".$this->formName."_sort_order=".$this->actualSortOrder;

        if(count($this->lines) > 0)
        {
          if($this->actualSortOrder == 'UP')
            usort($this->lines, array($this->lines[0]->className(), "sortCmpUp_$this->actualSortField"));
          else
            usort($this->lines, array($this->lines[0]->className(), "sortCmpDwn_$this->actualSortField"));
        }
      }
    else
      $sortLink = '';
  $tabClass = 'table02';
  for($l = 0; $l < count($this->lines); $l++)
    {
      print "<TR>\n";
      $line = $this->lines[$l];
      if(count($widths) != 0)
        $widthTag = "WIDTH=\"%%WIDTH%%\"";
      $line->display("<TD CLASS=\"$tabClass\" $widthTag VALIGN=\"TOP\">", '</TD>', $widths);
      if($this->modifyFlag || $this->deleteFlag)
        {
          if(count($widths) != 0)
            $widthTag = "WIDTH=\"".$widths[count($widths) - 1]."\"";
          print "<TD CLASS=\"$tabClass\" $widthTag ALIGN=\"$alignChangeDelete\" VALIGN=\"TOP\">";
          if($classHeader != '')
            $c = " class=\"$classHeader\"";
          else
            $c = '';
          if($this->modifyFlag)
            switch($changeDeleteType)
            {
              case $this->TABLELINK:
                print "<A$c HREF=\"".$this->formAction.$sep."inc_table_".$this->formName."_action=".$this->formName."_change&".$this->formName."_id=".$line->id()."$sortLink\">$changeText</A>&nbsp;";
              break;
              case $this->TABLESUBMIT:
                print "<INPUT TYPE=\"submit\"$c NAME=\"".$this->formName."_ts=true&".$this->formAction.$sep."inc_table_".$this->formName."_action=".$this->formName."_change&".$this->formName."_id=".$line->id()."$sortLink\" VALUE=\"$changeText\">&nbsp;";
              break;
              case $this->TABLEIMAGE:
                print "<INPUT TYPE=\"image\"$c NAME=\"".$this->formName."_ts=true&".$this->formAction.$sep."inc_table_".$this->formName."_action=".$this->formName."_change&".$this->formName."_id=".$line->id()."$sortLink\" SRC=\"$changeText\" ALT=\""._('&Auml;ndern')."\" TITLE=\""._('&Auml;ndern')."\">&nbsp;";
              break;
            }
          if($this->deleteFlag)
            switch($changeDeleteType)
            {
              case $this->TABLELINK:
                print "<A$c HREF=\"".$this->formAction.$sep."inc_table_".$this->formName."_action=".$this->formName."_delete&".$this->formName."_id=".$line->id()."$sortLink\">$deleteText</A>";
              break;
              case $this->TABLESUBMIT:
                print "<INPUT TYPE=\"submit\"$c NAME=\"".$this->formName."_ts=true&".$this->formAction.$sep."inc_table_".$this->formName."_action=".$this->formName."_delete&".$this->formName."_id=".$line->id()."$sortLink\" VALUE=\"$deleteText\">";
              break;
              case $this->TABLEIMAGE:
                print "<INPUT TYPE=\"image\"$c NAME=\"".$this->formName."_ts=true&".$this->formAction.$sep."inc_table_".$this->formName."_action=".$this->formName."_delete&".$this->formName."_id=".$line->id()."$sortLink\" SRC=\"$deleteText\" ALT=\""._('L&ouml;schen')."\" TITLE=\""._('L&ouml;schen')."\">";
              break;
            }
          print "</TD>\n";
        }
      print "</TR>\n";
	  if($tabClass == 'table02')
	  	$tabClass = 'table03';
      else
	  	$tabClass = 'table02';
    }
?>
</TABLE>
<?
    if($newForm == 1) print "</FORM>\n";
  }

  function displayEditNew($class, $width = '100%', $border = 0, $newForm = 1, $table = 1, $cellspacing = 1, $cellpadding = 2, $addChangeType = '', $addImage = '/images/add.png', $changeImage = '/images/edit.png')
  {
    if($addChangeType == '' || $addChangeType == $this->TABLELINK)
      $addChangeType = $this->TABLESUBMIT;
    if($newForm == 1)
      {
?>
<FORM NAME="<? print $this->formName; ?>_editnew" ACTION="<? print $this->formAction; ?>" METHOD="POST">
<?
      }
?>
<INPUT TYPE="Hidden" NAME="inc_table_<? print $this->formName; ?>_action" VALUE="<? print $this->formName; if($this->newedit == 0) print "_new"; else print "_edit"; ?>">
<INPUT TYPE="Hidden" NAME="<? print $this->formName.'_class'; ?>" VALUE="<? print $class; ?>">
<INPUT TYPE="Hidden" NAME="<? print $this->formName.'_sort_field'; ?>" VALUE="<? print $this->actualSortField; ?>">
<INPUT TYPE="Hidden" NAME="<? print $this->formName.'_sort_order'; ?>" VALUE="<? print $this->actualSortOrder; ?>">
<?
    if($this->newedit == 1)
      print "<INPUT TYPE=\"Hidden\" NAME=\"".$this->formName."_field_id\" VALUE=\"".$this->editid."\">";

    if($table == 1)
      {
?>
<TABLE WIDTH="<? print $width; ?>" BORDER="<? print $border; ?>" cellspacing="<? print $cellspacing; ?>" cellpadding="<? print $cellpadding; ?>" ID="<? print $this->formName; ?>_editnew_form">
  <TR>
<?
      }
    if($this->newedit == 0)
      $line = new $class(-1);
    if($this->newedit == 1)
      {
        foreach($this->lines as $l)
          if($l->id() == $this->editid)
            $line = $l;
      }
    $fields = $line->fields();
    for($l = 0; $l < count($line->fields()); $l++)
      {
        if($table == 1)
          print "<TD>";
        if($this->errors)
          $value = $_REQUEST[$this->formName.'_field_'.$fields[$l]];
        else
          if($this->newedit == 0)
            $value = '';
          else
            $value = $line->$fields[$l];
        if($this->newedit == 0)
          $line->displayFieldsForEdit($this->formName, $fields[$l], $value);
        if($this->newedit == 1)
          $line->displayFieldsForEdit($this->formName, $fields[$l], $value);
        if($table == 1)
          print "</TD>\n";
      }
    if($table == 1)
      {
        if($this->newedit == 0)
          switch($addChangeType)
          {
            case $this->TABLESUBMIT:
              print "<TD WIDTH=\"10%\"><INPUT TYPE=\"Submit\" class=\"button\" NAME=\"".$this->formName."_submit\" VALUE=\""._('Hinzuf&uuml;gen')."\"></TD>\n";
            break;
            case $this->TABLEIMAGE:
              print "<TD WIDTH=\"10%\"><INPUT TYPE=\"image\" NAME=\"".$this->formName."_ts=true&inc_table_".$this->formName."_action=".$this->formName."_new\" SRC=\"$addImage\" TITLE=\""._('Hinzuf&uuml;gen')."\" ALT=\""._('Hinzuf&uuml;gen')."\"></TD>\n";
            break;
          }
        if($this->newedit == 1)
          switch($addChangeType)
          {
            case $this->TABLESUBMIT:
              print "<TD WIDTH=\"10%\"><INPUT TYPE=\"Submit\" class=\"button\" NAME=\"".$this->formName."_submit\" VALUE=\""._('&Auml;ndern')."\"></TD>\n";
            break;
            case $this->TABLEIMAGE:
              print "<TD WIDTH=\"10%\"><INPUT TYPE=\"image\" NAME=\"".$this->formName."_ts=true&inc_table_".$this->formName."_action=".$this->formName."_edit\" SRC=\"$changeImage\" TITLE=\""._('&Auml;ndern')."\" ALT=\""._('&Auml;ndern')."\"></TD>\n";
            break;
          }
      }
    else
      {
        if($this->newedit == 0)
          switch($addChangeType)
          {
            case $this->TABLESUBMIT:
              print "<br><INPUT TYPE=\"Submit\" class=\"button\" NAME=\"".$this->formName."_submit\" VALUE=\""._('Hinzuf&uuml;gen')."\">\n";
            break;
            case $this->TABLEIMAGE:
              print "<br><INPUT TYPE=\"image\" NAME=\"".$this->formName."_submit\" SRC=\"$addImage\" TITLE=\""._('Hinzuf&uuml;gen')."\" ALT=\""._('Hinzuf&uuml;gen')."\">\n";
            break;
          }
          print "<br><INPUT TYPE=\"Submit\" class=\"button\" NAME=\"".$this->formName."_submit\" VALUE=\""._('Hinzuf&uuml;gen')."\">\n";
        if($this->newedit == 1)
          switch($addChangeType)
          {
            case $this->TABLESUBMIT:
              print "<br><INPUT TYPE=\"Submit\" class=\"button\" NAME=\"".$this->formName."_submit\" VALUE=\""._('&Auml;ndern')."\">\n";
            break;
            case $this->TABLEIMAGE:
              print "<br><INPUT TYPE=\"image\" NAME=\"".$this->formName."_ts=true&inc_table_".$this->formName."_action=".$this->formName."_edit\" SRC=\"$changeImage\" TITLE=\""._('&Auml;ndern')."\" ALT=\""._('&Auml;ndern')."\">\n";
            break;
          }
      }
    if($table == 1)
      {
?>
  </TR>
</TABLE>
<?
      }
    if($newForm == 1) print "</FORM>\n";
  }
}
?>
