<?
/*******************************************************************************
*    WMail 1.0. Webmail for PHP                                                *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

require_once('auth.inc.php');
require_once('session.inc.php');
require_once('addbook.inc.php');
require_once('email.inc.php');

if($doSearch_x != '' || $doSearch_y != '')
  $doSearch = 'true';

$separators = array(',' => ',', ';' => ';', 'TAB' => '\t', '&brvbar;' => '|');

$auth = $session[auth_data];
$addbook = new Table('addbook', "addbook.php?sid=".session_id()."&addbook_class=AddBook", false, false, false);

if($back != '' && $toview != '')
{
  header("LOCATION: view.php?sid=".session_id()."&setMailbox=$setMailbox&msg=$msg&isSent=$isSent");
  exit;
}

if($impex == 'true' && $back != '')
  $impex = '';

if($doImport != '')
{
  if($importFile == '')
    $importError = _('CSV-Datei nicht eingegeben');
  else
  {
    if($iSeparator == "\\\\t")
      $iSeparator = "\t";
    dbConnect();
    $fp = fopen($importFile, 'rt');
    while(!feof($fp))
    {
      $line = chop(fgets($fp));
      if($line != '')
      {
        list ($nick, $name, $email, $remarks) = explode($iSeparator, $line);
        if($email != '')
        {
          $res = dbQuery("SELECT COUNT(*) AS C FROM addressbook WHERE account = '".$auth->getAccountname()."' AND nick = '$nick'");
          $val = dbFetchArray($res);
          if($val[0] != 0)
          {
            if($overwrite != '')
              dbQuery("UPDATE addressbook SET name = '$name' email = '$email' remarks = '".dbEscape($remarks)."' WHERE account = '".$auth->getAccountname()."' AND nick = '$nick'");
            else
              $importError = _('Es gibt duplizierte Eintr&auml;ge.<br>Sie sind NICHT importiert worden');
          }
          else
            dbQuery("INSERT INTO addressbook (account, nick, name, email, remarks) VALUES ('".$auth->getAccountname()."', '$nick', '$name', '$email', '".dbEscape($remarks)."')");
        }
        else
          $importError = _('Es gibt ung&uuml;ltige Eintr&auml;ge.<br>Nicht alle S&auml;tze sind importiert worden');
      }
    }
    fclose($fp);
    dbDisconnect();
  }
}
if($doExport != '')
{
  if($eSeparator == "\\\\t")
    $eSeparator = "\t";
  header('Content-type: text/plain');
  header('Content-Disposition: attachment; filename="addbook_'.$auth->getAccountname().'.csv"');
  header("Accept-Ranges: bytes");
  header("Expires: 0");
  header("Cache-Control: private");
  header("Content-Transfer-Encoding: quoted-printable");
  header("Pragma: private");
  dbConnect();
  $res = dbQuery("SELECT nick, name, email, remarks FROM addressbook WHERE account = '".$auth->getAccountname()."' ORDER BY nick");
  while($val = dbFetchArray($res))
    print "$val[0]$eSeparator$val[1]$eSeparator$val[2]$eSeparator$val[3]\r\n";
  dbDisconnect();
  exit;
}

dbConnect();

if($editab != '' && $back != '')
  $editab = '';
if($new != '' && $back != '')
  $new = '';

if($new != '' && $save != '')
{
  if($abNick == '')
    $error = _('Ung&uuml;ltiger Spitzname');
  if($abEMail == '' || !isValidEmail($abEMail))
    $error = _('Ung&uuml;ltige E-Mail Adresse');
  $res = dbQuery("SELECT COUNT(*) AS C FROM addressbook WHERE account = '".$auth->getAccountname()."' AND nick = '$abNick'");
  $val = dbFetchArray($res);
  if($val[0] != 0)
    $error = _('Spitzname ist schon vergeben');
  if($error == '')
  {
    $abRemarks = str_replace("\'", "'", $abRemarks);
    dbQuery("INSERT INTO addressbook (account, nick, name, email, remarks) VALUES ('".$auth->getAccountname()."', '$abNick', '$abName', '$abEMail', '".dbEscape($abRemarks)."')");
    $new = '';
  }
}

if($toadd != '')
{
  if(strpos($toadd, '<') != 0)
  {
    $abName = substr($toadd, 0, strpos($toadd, '<') - 1);
    $abEMail = strtolower(substr($toadd, strpos($toadd, '<') + 1, strpos($toadd, '>') - strpos($toadd, '<') - 1));
  }
  else
    $abEMail = strtolower($toadd);
}

if($editab != '' && $delete != '')
{
  dbQuery("DELETE FROM addressbook WHERE account = '".$auth->getAccountname()."' AND id = $editab");
  $editab = '';
}

if($editab != '' && $save != '')
{
  if($abNick == '')
    $error = _('Ung&uuml;ltiger Spitzname');
  if($abEMail == '' || !isValidEmail($abEMail))
    $error = _('Ung&uuml;ltige E-Mail Adresse');
  $res = dbQuery("SELECT COUNT(*) AS C FROM addressbook WHERE account = '".$auth->getAccountname()."' AND nick = '$abNick' AND id != $editab");
  $val = dbFetchArray($res);
  if($val[0] != 0)
    $error = _('Spitzname ist schon vergeben');
  if($error == '')
  {
    $abRemarks = str_replace("\'", "'", $abRemarks);
    $abRemarks = str_replace("\\\"", "\"", $abRemarks);
    $abRemarks = str_replace("\\\\", "\\", $abRemarks);
    dbQuery("UPDATE addressbook SET nick = '$abNick', name = '$abName', email = '$abEMail', remarks = '".dbEscape($abRemarks)."' WHERE account = '".$auth->getAccountname()."' AND id = $editab");
    $editab = '';
  }
}

if($save != '' && $toview != '' && $error == '')
{
  header("LOCATION: view.php?sid=".session_id()."&setMailbox=$setMailbox&msg=$msg&isSent=$isSent");
  exit;
}

if($editab == '')
{
  if($viewAll != '' || ($doSearch != '' && $searchAddr == ''))
  {
    $doSearch = '';
    $searchAddr = '';
  }
  if($doSearch != '')
  {
    $s = strtolower($searchAddr);
    $res = dbQuery("SELECT id, nick, name, email FROM addressbook WHERE account = '".$auth->getAccountname()."' AND (LOWER(nick) LIKE '%$s%' OR LOWER(name) LIKE '%$s%' OR LOWER(email) LIKE '%$s%') ORDER BY nick");
  }
  else
    $res = dbQuery("SELECT id, nick, name, email FROM addressbook WHERE account = '".$auth->getAccountname()."' ORDER BY nick");
  while($val = dbFetchArray($res))
    $addbook->addLine(new AddBook($val[0], $val[1], $val[2], $val[3]));
}
else
{
  if($error == '')
  {
    $res = dbQuery("SELECT nick, name, email, remarks FROM addressbook WHERE account = '".$auth->getAccountname()."' AND id = $editab");
    $val = dbFetchArray($res);
    $abNick = $val[0];
    $abName = $val[1];
    $abEMail = $val[2];
    $abRemarks = $val[3];
  }
}
dbDisconnect();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title><? echo _('WMail: ein Webmail f&uuml;r PHP'); ?></title>
<meta content='width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0' name='viewport' />
<meta name="viewport" content="width=device-width" />
<link href="/images/default.css" rel="stylesheet" type="text/css">
<link href="/images/mobile.css" media='all and (max-width: 839px)' rel="stylesheet" type="text/css"  />
<link rel="shortcut icon" href="/images/wmlogo.ico" >
</head>
<body>
<?
include_once 'menu.inc.php';
include_once 'mailboxes.inc.php';

if(count($addbook->lines) > 7)
{
  $divHeight = 158;
  $wh1 = 40;
  $wh2 = 100;
  $wh3 = 220;
  $wh4 = 240;
  $w1 = 16;
  $w2 = 98;
  $w3 = 264;
  $w4 = 222;
}
else
{
  if(count($addbook->lines) == 0)
    $divHeight = 20;
  else
    $divHeight = 20 * count($addbook->lines);
  $wh1 = 40;
  $wh2 = 100;
  $wh3 = 220;
  $wh4 = 240;
  $w1 = 16;
  $w2 = 97;
  $w3 = 239;
  $w4 = 248;
}
?>
<div id="addbookDIV">
<?
if($editab == '' && $new != 'true' && $impex != 'true')
{
?>
<form action="addbook.php?sid=<? print session_id(); ?>" method="post">
  <table width="100%" cellpadding="0" cellspacing="0">
    <tr>
      <td class="addbook" width="100%">
        <table width="100%" cellpadding="0" cellspacing="0" border="0">
          <tr>
            <td colspan="2" width="100%" style="height:5px;"></td>
          </tr>
          <tr>
            <td valign="top" class="title" width="40%"><? echo _('Adressbuch').':'; ?><br><br></td>
            <td valign="top" align="left" class="title" width="60%">
              <table width="150" cellpadding="0" cellspacing="0">
                <tr>
                  <td align="center" width="75" valign="middle"><a href="addbook.php?sid=<? print session_id(); ?>&new=true"><img src="/images/newab.png" border="0" alt="<? echo _('Neuen Kontakt hinzuf&uuml;gen'); ?>"></a></td>
                  <td align="center" width="75" valign="middle"><a href="addbook.php?sid=<? print session_id(); ?>&impex=true"><img src="/images/impexpab.png" border="0" alt="<? echo _('Import/Export'); ?>"></a></td>
                </tr>
                <tr>
                  <td align="center" width="75" valign="top"><a class="menu" href="addbook.php?sid=<? print session_id(); ?>&new=true"><span style="font-size:11px;font-weight:bold;font-style:normal;"><? echo _('Neuen Kontakt hinzuf&uuml;gen'); ?></span></a></td>
                  <td align="center" width="75" valign="top"><a class="menu" href="addbook.php?sid=<? print session_id(); ?>&impex=true"><span style="font-size:11px;font-weight:bold;font-style:normal;"><? echo _('Import/Export'); ?></span></a></td>
                </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">
              <table width="600" border="0" cellspacing="1" cellpadding="0">
                <tr>
                  <td width="400"><input type="text" style="width:380px;" name="searchAddr" value="<? echo $searchAddr; ?>"></td>
                  <td width="200">
                    <input type="image" name="doSearch" src="/images/searchab.png" alt="<? echo _('Suchen'); ?>" title="<? echo _('Suchen'); ?>">
<?
if($doSearch != '')
{
?>
                    <input type="image" name="viewAll" src="/images/browse.png" alt="<? echo _('Alle zeigen'); ?>" title="<? echo _('Alle zeigen'); ?>">
<?
}
?>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
          <tr>
            <td colspan="2" width="100%">
              <table width="600" border="0" cellspacing="1" cellpadding="0">
                <tr>
                  <th class="addbook" width="<? echo $wh1; ?>" style="border-left-width:1px; border-left-style:solid;">&nbsp;</th>
                  <th class="addbook" width="<? echo $wh2; ?>"><? echo _("Spitzname"); ?></th>
                  <th class="addbook" width="<? echo $wh3; ?>"><? echo _("Name"); ?></th>
                  <th class="addbook" width="<? echo $wh4; ?>"><? echo _("E-Mail"); ?></th>
                </tr>
                <tr>
                  <td colspan="4">
                    <div id="Layer1" style="border-width:1px; border-style:solid; width:600px; z-index:1; <? if(count($addbook->lines) > 7) print "overflow: auto; "; ?> height: <? print $divHeight; ?>px;">
<?
if(count($addbook->lines) == 0)
{
?>
                      <table width="600">
                        <tr>
                          <td align="center" style="height:15px;"><span style="font-size:13px; font-weight:normal; font-style:italic;"><? if($doSearch != '') echo _(sprintf('%s wurde nicht gefunden', $searchAddr)); else echo _('Sie haben noch keinen Kontakt eingetragen'); ?></span></td>
                        </tr>
                      </table>
<?
}
else
  $addbook->displayTable("100%", 0, 0, array($w1, $w2, $w3, $w4), 0, 2, 'identity');
?>
                    </div>
                  </td>
                </tr>
              </table>
            </td>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
<?
}
else
{
  if($impex == 'true')
  {
    if($eSeparator == '')
      $eSeparator = ',';
    if($iSeparator == '')
      $iSeparator = ',';
?>
<form action="addbook.php?sid=<? print session_id(); ?>&impex=true" method="post" enctype="multipart/form-data">
  <table width="100%" cellpadding="0" cellspacing="0">
    <tr>
      <td class="addbook" width="100%">
        <table width="550" cellpadding="0" cellspacing="0">
          <tr>
            <td colspan="2" class="title" width="100%"><? echo _('Adressbuch').':'; ?><br><br></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
          <tr>
            <td colspan="2" width="100%"><b><? echo _('Kontakte von CSV-Datei importieren').':'; ?></b></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
<?
    if($importError != '')
    {
?>
          <tr>
            <td colspan="2" width="100%" class="error"><? echo $importError; ?></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
<?
    }
?>
          <tr>
            <td width="450" style="font-size:12px;font-weight:normal;font-style:normal;">
              <input type="file" class="button" style="width:300px;height:18px;" name="importFile">&nbsp;&nbsp;&nbsp;
              <? echo _('Trennzeichen:'); ?>&nbsp;
              <select name="iSeparator" style="width:50px;">
<?
    foreach(array_keys($separators) as $s)
      if($iSeparator == $separators[$s])
        print "<option selected value=\"$separators[$s]\">$s</option>\n";
      else
        print "<option value=\"$separators[$s]\">$s</option>\n";
?>
              </select>
            </td>
            <td width="100" style="font-size:12px;font-weight:normal;font-style:normal;">
              <input type="submit" name="doImport" class="button" value="<? echo _('Importieren'); ?>">
            </td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="font-size:12px;font-weight:normal;font-style:normal;"><input type="CheckBox" name="overwrite" value="yes">&nbsp;<? echo _('Existierende Daten &uuml;berschreiben'); ?></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
          <tr>
            <td colspan="2" width="100%"><b><? echo _('Kontakte als CSV-Datei exportieren').':'; ?></b></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
          <tr>
            <td width="450" style="font-size:12px;font-weight:normal;font-style:normal;">
              <? echo _('Trennzeichen:'); ?>&nbsp;
              <select name="eSeparator" style="width:50px;">
<?
    foreach(array_keys($separators) as $s)
      if($eSeparator == $separators[$s])
        print "<option selected value=\"$separators[$s]\">$s</option>\n";
      else
        print "<option value=\"$separators[$s]\">$s</option>\n";
?>
              </select>
            </td>
            <td width="100" style="font-size:12px;font-weight:normal;font-style:normal;">
              <input type="submit" name="doExport" class="button" value="<? echo _('Exportieren'); ?>">
            </td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
          <tr>
            <td colspan="2" width="100%"><input type="submit" name="back" class="button" value="<? echo _('Zur&uuml;ck'); ?>"></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
<?
  }
  else
  {
    if($new == '')
    {
?>
<form action="addbook.php?sid=<? print session_id(); ?>&editab=<? print $editab; ?>" method="post">
<?
    }
    else
    {
?>
<form action="addbook.php?sid=<? print session_id(); ?>&new=true" method="post">
<?
    }

if($toadd != '')
  print "<input type=\"hidden\" name=\"toadd\" value=\"".$toadd."\">\n<input type=\"hidden\" name=\"setMailbox\" value=\"".$setMailbox."\">\n<input type=\"hidden\" name=\"toview\" value=\"true\">\n<input type=\"hidden\" name=\"isSent\" value=\"$isSent\">\n<input type=\"hidden\" name=\"msg\" value=\"$msg\">\n";
?>
  <table width="100%" cellpadding="0" cellspacing="0">
    <tr>
      <td class="addbook" width="100%">
        <table width="100%" cellpadding="0" cellspacing="0">
          <tr>
            <td colspan="2" class="title" width="100%"><? echo _('Adressbuch').':'; ?><br><br></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
          <tr>
            <td colspan="2" width="100%"><b><? if($new == '') echo sprintf(_('Detail des Kontaktes &quot;%s&quot;'), $abNick).':'; else echo _('Neuer Kontakt').':'; ?></b></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
          <tr>
            <td colspan="2" width="100%">
              <table width="500" cellpadding="0" cellspacing="0">
                <tr>
                  <td width="100"><? echo _('Spitzname').':'; ?></td>
                  <td width="400" colspan="2"><input type="Text" name="abNick" value="<? echo $abNick; ?>" maxlength="255" style="width:400px;"></td>
                </tr>
                <tr>
                  <td width="100"><? echo _('Name').':'; ?></td>
                  <td width="400" colspan="2"><input type="Text" name="abName" value="<? echo $abName; ?>" maxlength="255" style="width:400px;"></td>
                </tr>
                <tr>
                  <td width="100"><? echo _('E-Mail').':'; ?></td>
                  <td width="400" colspan="2"><input type="Text" name="abEMail" value="<? echo $abEMail; ?>" maxlength="255" style="width:400px;"></td>
                </tr>
                <tr>
                  <td width="100" valign="top"><? echo _('Bemerkungen').':'; ?></td>
                  <td width="400" colspan="2" valign="top">
                    <textarea rows=15 cols=64 wrap="soft" style="width:404px; height: 150px;" name="abRemarks">
<? echo $abRemarks; ?></textarea>
                  </td>
                </tr>
                <tr>
                  <td colspan="3" width="500" style="height:15px;">&nbsp;</td>
                </tr>
<?
    if($error != '')
    {
?>
                <tr>
                  <td colspan="3" width="500" class="error" style="height:15px;"><? echo $error; ?></td>
                </tr>
                <tr>
                  <td colspan="3" width="500" style="height:15px;">&nbsp;</td>
                </tr>
<?
    }
    if($new == '')
    {
?>
                <tr>
                  <td width="500" colspan="3">
                    <table width="100%" cellpadding="0" cellspacing="0">
                      <tr>
                        <td width="167" valign="top" align="left"><input type="submit" class="button" name="save" value="<? echo _('Speichern'); ?>"></td>
                        <td width="166" valign="top" align="center"><input type="submit" class="button" name="delete" value="<? echo _('L&ouml;schen'); ?>"></td>
                        <td width="167" valign="top" align="right"><input type="submit" class="button" name="back" value="<? echo _('Zur&uuml;ck'); ?>"></td>
                      </tr>
                    </table>
                  </td>
                </tr>
<?
    }
    else
    {
?>
                <tr>
                  <td width="100" valign="top" align="left"><input type="submit" class="button" name="save" value="<? echo _('Speichern'); ?>"></td>
                  <td width="400" valign="top" align="right" colspan="2"><input type="submit" class="button" name="back" value="<? echo _('Zur&uuml;ck'); ?>"></td>
                </tr>
<?
    }
  }
?>
                <tr>
                  <td colspan="3" width="500" style="height:15px;">&nbsp;</td>
                </tr>
              </table>
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
<?
}
?>
</form>
</div>
</body>
</html>
