<?
/*******************************************************************************
*    WMail 1.0. Webmail for PHP                                                *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

require_once('auth.inc.php');
require_once('session.inc.php');
require_once('identities.inc.php');
require_once('attribute.inc.php');

$auth = $session[auth_data];
$identity = new Table('identity', "prefs.php?sid=".session_id()."&identity_class=Identity", false, true, true);

dbConnect();
if($back != '')
{
  $identity->deleteFromDBSession(session_id());
  header("LOCATION: main.php?sid=".session_id());
  dbDisconnect();
  exit;
}
if($inc_table_identity_action == '')
{
  $res = dbQuery("SELECT id, name, aliasname, isdefault FROM alias WHERE account = '".$auth->getAccountname()."' ORDER BY isdefault");
  while($val = dbFetchArray($res))
    $identity->addLine(new Identity($val[0], $val[1], $val[2], $val[3]));
  $identity->saveToDBSession(session_id());
  $dateFormat = getAttribute('DATEFORMAT', '%D.%M.%Y %H:%I.%S');
  $copySent = getAttribute('COPYSENT', 'yes');
  $defaultBcc = getAttribute('DEFAULTBCC', '');
  $userHeader = getAttribute('USERHEADER_HEADER', '');
  $userHeaderData = getAttribute('USERHEADER_DATA', '');
  $xFace = getAttribute('XFACE', '');
  $signature = getAttribute('SIGNATURE', '');
  $answerPrefix = getAttribute('ANSWERPREFIX', _('AW:'));
  $answerQuoteSymbol = getAttribute('ANSWERQUOTESYMBOL', '>');
  $answerQuoteString = getAttribute('ANSWERQUOTESTRING', '%f '._('schrieb').":\n%Q");
  $forwardPrefix = getAttribute('FORWARDPREFIX', _('WG:'));
  $forwardQuoteSymbol = getAttribute('FORWARDQUOTESYMBOL', '>');
  $forwardQuoteString = getAttribute('FORWARDQUOTESTRING', "\n"._('Weitergeleitete Nachricht').":\n\n"._('Datum').": %d\n"._('Von').": %f\n"._('An').": %t\n"._('Cc').": %c\n"._('Betreff').": %s\n\n%m");
}
else
{
  $identity->loadFromDBSession(session_id());
  $xFace = str_replace("\'", "'", $xFace);
  $xFace = str_replace("\\\"", "\"", $xFace);
  $xFace = str_replace("\\\\", "\\", $xFace);
}

if($identity->hasToWork() && $save == '' && $back == '')
{
  $identity->manage();
  if($_REQUEST['identity_field_isDefault'] == 't')
  {
    $nLines = array();
    foreach($identity->lines as $line)
    {
      if($line->id() != $_REQUEST['identity_field_id'])
        if($_REQUEST['inc_table_identity_action'] == 'identity_new' && $_REQUEST['identity_field_addr'] == $line->addr)
          $line->isDefault = 't';
        else
          $line->isDefault = 'f';
      $nLines[] = $line;
    }
    $identity->lines = $nLines;
  }
  $identity->saveToDBSession(session_id());
}

if($save != '')
{
  dbQuery("DELETE FROM alias WHERE account = '".$auth->getAccountname()."'");
  foreach($identity->lines as $line)
  {
    if($line->isDefault == '')
      $line->isDefault = 'f';
    dbQuery("INSERT INTO alias (account, name, aliasname, isdefault) VALUES ('".$auth->getAccountname()."', '".$line->name."', '".$line->addr."', '".$line->isDefault."')");
  }
  $identity->deleteFromDBSession(session_id());
  $auth->resetAliases();
  saveAttribute('DATEFORMAT', $dateFormat);
  saveAttribute('COPYSENT', $copySent);
  saveAttribute('DEFAULTBCC', $defaultBcc);
  saveAttribute('USERHEADER_HEADER', $userHeader);
  saveAttribute('USERHEADER_DATA', $userHeaderData);
  saveAttribute('XFACE', $xFace);
  saveAttribute('SIGNATURE', $signature);
  saveAttribute('ANSWERPREFIX', $answerPrefix);
  saveAttribute('ANSWERQUOTESYMBOL', $answerQuoteSymbol);
  saveAttribute('ANSWERQUOTESTRING', $answerQuoteString);
  saveAttribute('FORWARDPREFIX', $forwardPrefix);
  saveAttribute('FORWARDQUOTESYMBOL', $forwardQuoteSymbol);
  saveAttribute('FORWARDQUOTESTRING', $forwardQuoteString);
  $res = dbQuery("SELECT name, aliasname, isdefault FROM alias WHERE account = '".$auth->getAccountname()."' ORDER BY isdefault");
  while($val = dbFetchArray($res))
    $auth->addAlias($val[0], $val[1], $val[2]);
  $session[auth_data] = $auth;
  header("LOCATION: main.php?sid=".session_id());
  dbDisconnect();
  exit;
}

dbDisconnect();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title><? echo _('WMail: ein Webmail f&uuml;r PHP'); ?></title>
<meta content='width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0' name='viewport' />
<meta name="viewport" content="width=device-width" />
<link href="/images/default.css" rel="stylesheet" type="text/css">
<link href="/images/mobile.css" media='all and (max-width: 839px)' rel="stylesheet" type="text/css"  />
<link rel="shortcut icon" href="/images/wmlogo.ico" >
<script type="text/javascript">

// -------------------------------------------------------
// This code was written by Tyler Akins and has been placed in the
// public domain.  It would be nice if you left this header intact.
// Base64 code from Tyler Akins -- http://rumkin.com

var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

function encode64(input) {
   var output = "";
   var chr1, chr2, chr3;
   var enc1, enc2, enc3, enc4;
   var i = 0;

   do {
      chr1 = input.charCodeAt(i++);
      chr2 = input.charCodeAt(i++);
      chr3 = input.charCodeAt(i++);

      enc1 = chr1 >> 2;
      enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
      enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
      enc4 = chr3 & 63;

      if (isNaN(chr2)) {
         enc3 = enc4 = 64;
      } else if (isNaN(chr3)) {
         enc4 = 64;
      }

      output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) + 
         keyStr.charAt(enc3) + keyStr.charAt(enc4);
   } while (i < input.length);
   
   return output;
}
// -------------------------------------------------------

function displayXFace(xFaceData)
{
  w = window.open('', '<? echo _('X-Face'); ?>', 'scrollbars=no,width=50, height=80');
  w.document.writeln('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">');
  w.document.writeln('<html>');
  w.document.writeln('<head>');
  w.document.writeln('<title><? echo _('X-Face'); ?></title>');
  w.document.writeln('<link href="/images/default.css" rel="stylesheet" type="text/css">');
  w.document.writeln('</head>');
  w.document.writeln('<p align="center"><img border="0" src="xface.php?xf=' + encode64(xFaceData) + '" alt="<? echo _('X-Face'); ?>">');
  w.document.writeln('<form>');
  w.document.writeln('<input type="button" class="button" name="close" onClick="window.close();" value="<? echo _('Fenster schlie&szlig;en'); ?>">');
  w.document.writeln('</form></p>');
  w.document.writeln('</html>');
  w.document.close();
}

function displayDateFormat()
{
  w = window.open('', '<? echo _('Beschreibung der Symbole').':'; ?>', 'scrollbars=yes,width=300, height=250');
  w.document.writeln('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">');
  w.document.writeln('<html>');
  w.document.writeln('<head>');
  w.document.writeln('<title><? echo _('Beschreibung der Symbole').':'; ?></title>');
  w.document.writeln('<link href="/images/default.css" rel="stylesheet" type="text/css">');
  w.document.writeln('</head>');
  w.document.writeln('<center><h2 style="color:black;"><? echo _('Beschreibung der Symbole').':'; ?></h2></center>');
  w.document.writeln('<table width="290" cellpadding="0" cellspacing="0">');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;Y</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Jahr, 4 stellig'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;y</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Jahr, 2 stellig'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;D</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Tag des Monats (01..31)'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;M</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Monat (01..12)'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;H</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Stunde einer 24-Std. Uhr (00..23)'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;I</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Minuten (00..59)'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;S</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Sekunden (00..59)'); ?></td></tr>');
  w.document.writeln('</table><br>');
  w.document.writeln('<p align="center"><form>');
  w.document.writeln('<input type="button" class="button" name="close" onClick="window.close();" value="<? echo _('Fenster schlie&szlig;en'); ?>">');
  w.document.writeln('</form></p>');
  w.document.writeln('</html>');
  w.document.close();
}

function displaySymbolDescription()
{
  w = window.open('', '<? echo _('Beschreibung der Symbole').':'; ?>', 'scrollbars=yes,width=300, height=250');
  w.document.writeln('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">');
  w.document.writeln('<html>');
  w.document.writeln('<head>');
  w.document.writeln('<title><? echo _('Beschreibung der Symbole').':'; ?></title>');
  w.document.writeln('<link href="/images/default.css" rel="stylesheet" type="text/css">');
  w.document.writeln('</head>');
  w.document.writeln('<center><h2 style="color:black;"><? echo _('Beschreibung der Symbole').':'; ?></h2></center>');
  w.document.writeln('<table width="290" cellpadding="0" cellspacing="0">');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;d</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Datum'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;f</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Von'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;t</td><td width="260" style="color:black;font-weight:normal;"><? echo _('An'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;c</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Cc'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;s</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Betreff'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;Q</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Zitierter Nachrichtenk&ouml;rper'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#37;m</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Nachrichtenk&ouml;rper'); ?></td></tr>');
  w.document.writeln('<tr><td width="35" style="color:black;padding-left:20px;font-size:14px;font-family:Courier;">&#92;&#37;</td><td width="260" style="color:black;font-weight:normal;"><? echo _('Symbol f&uuml;r &#37;'); ?></td></tr>');
  w.document.writeln('</table><br>');
  w.document.writeln('<p align="center"><form>');
  w.document.writeln('<input type="button" class="button" name="close" onClick="window.close();" value="<? echo _('Fenster schlie&szlig;en'); ?>">');
  w.document.writeln('</form></p>');
  w.document.writeln('</html>');
  w.document.close();
}
</script>
</head>
<body>
<?
include_once 'menu.inc.php';
include_once 'mailboxes.inc.php';

if(count($identity->lines) == 0)
  $aliasError = _('Sie haben noch keinen Alias konfiguriert.<br>Um WMail benutzen zu k&ouml;nnen, m&uuml;ssen Sie mindestens einen Alias (E-Mail Adresse) eingeben!');

if(count($identity->lines) > 6)
{
  $divHeight = 140;
  $wh1 = 264;
  $wh2 = 282;
  $wh3 = 54;
  $w1 = 266;
  $w2 = 282;
  $w3 = 52;
}
else
{
  if(count($identity->lines) == 0)
    $divHeight = 23;
  else
    $divHeight = 23 * count($identity->lines);
  $wh1 = 264;
  $wh2 = 282;
  $wh3 = 54;
  $w1 = 265;
  $w2 = 283;
  $w3 = 52;
}
?>
<form action="prefs.php?sid=<? print session_id(); ?>" method="post" name="prefs">
<div id="prefs" style="position:absolute; left:130px;top:70px;right:10px;">
  <table width="100%" cellpadding="0" cellspacing="0">
    <tr>
      <td class="prefs" width="100%">
        <table width="600" cellpadding="0" cellspacing="0">
          <tr>
            <td colspan="2" class="title" width="100%"><? echo _('Einstellungen').':'; ?><br><br></td>
          </tr>
          <tr>
            <td colspan="2" width="100%"><b><? echo _('Identit&auml;ten').':'; ?></b></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:5px;"></td>
          </tr>
<?
if($aliasError != '')
{
?>
          <tr>
            <td colspan="2" width="100%" class="error"><? echo $aliasError; ?></td>
          </tr>
<?
}
?>
          <tr>
            <td colspan="2" width="100%">
              <table width="600" border="0" cellspacing="1" cellpadding="0">
                <tr>
                  <th class="addbook" width="<? print $wh1; ?>" style="border-left-width:1px; border-left-style:solid;"><? echo _("Name"); ?></th>
                  <th class="addbook" width="<? print $wh2; ?>"><? echo _("E-Mail"); ?></th>
                  <th class="addbook" width="<? print $wh3; ?>">&nbsp;</th>
                </tr>
                <tr>
                  <td colspan="3">
                    <div id="Layer1" style="border-width:1px; border-style:solid; width:600px; z-index:1; <? if(count($identity->lines) > 6) print "overflow: auto; "; ?> height: <? print $divHeight; ?>px;">
<?
if(count($identity->lines) == 0)
{
?>
                      <table width="600">
                        <tr>
                          <td align="center" style="height:15px;"><span style="font-size:13px; font-weight:normal; font-style:italic;"><? echo _('Sie haben noch keinen Alias konfiguriert'); ?></span></td>
                        </tr>
                      </table>
<?
}
else
  $identity->displayTable(600, 0, 0, array($w1, $w2, $w3), 0, 2, 'identity', '/images/edit.png', '/images/delete.png', 'left', $identity->TABLEIMAGE);
?>
                    </div>
                  </td>
                </tr>
              </table>
            </td>
          <tr>
            <td colspan="2" width="100%" style="height:5px;"></td>
          </tr>
          <tr>
            <td colspan="2" width="100%">
<?
$identity->displayEditNew('Identity', 550, 0, 0, 1, 1, 2, $identity->TABLEIMAGE);
?>
            </td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:5px;"></td>
          </tr>
          <tr>
            <td colspan="2" width="600">
              <table width="600">
                <tr>
                  <td valign="middle" width="250" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Kopie der gesendeten E-Mails speichern').':'; ?></td>
                  <td valign="middle" width="350"><input type="Radio" name="copySent" value="yes"<? if($copySent == 'yes') echo 'checked="Checked"'; ?>>&nbsp;<? echo _('Ja'); ?>&nbsp;&nbsp;<input type="Radio" name="copySent" value="no"<? if($copySent == 'no') echo 'checked="Checked"'; ?>>&nbsp;<? echo _('Nein'); ?></td>
                </tr>
                <tr>
                  <td valign="middle" width="250" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Default BCC an').':'; ?></td>
                  <td valign="middle" width="350"><input type="text" style="width:350px;" name="defaultBcc" value="<? echo $defaultBcc; ?>"></td>
                </tr>
                <tr>
                  <td valign="middle" width="250" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Nutzerdefinierte Kopfzeile (Header)').':'; ?></td>
                  <td valign="middle" width="350"><input type="text" style="width:350px;" name="userHeader" value="<? echo $userHeader; ?>"></td>
                </tr>
                <tr>
                  <td valign="middle" width="250" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Daten der nutzerdefinierten Kopfzeile').':'; ?></td>
                  <td valign="middle" width="350"><input type="text" style="width:350px;" name="userHeaderData" value="<? echo $userHeaderData; ?>"></td>
                </tr>
                <tr>
                  <td valign="middle" width="250" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Datumsformat').':'; ?>&nbsp;&nbsp;&nbsp;<input type="button" class="button" name="dispDateFormat" onClick="displayDateFormat(); return false;" value="<? echo _('Beschreibung der Symbole'); ?>"></td>
                  <td valign="middle" width="350"><input type="text" style="width:350px;" name="dateFormat" value="<? echo $dateFormat; ?>"></td>
                  </td>
                </tr>
                <tr>
                  <td valign="top" width="250" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('X-Face Daten').':'; ?>&nbsp;&nbsp;&nbsp;<input type="button" class="button" name="dispXFace" onClick="displayXFace(document.prefs.xFace.value); return false;" value="<? echo _('X-Face zeigen'); ?>"></td>
                  <td valign="top" width="350">
                    <textarea rows=5 cols=64 wrap="soft" style="width:353px; height: 50px;" name="xFace">
<? echo $xFace; ?></textarea>
                  </td>
                </tr>
                <tr>
                  <td valign="top" width="250" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Unterschrift').':'; ?></td>
                  <td valign="top" width="350"><textarea rows=15 cols=64 wrap="soft" style="width:353px; height: 100px;" name="signature"><? echo $signature; ?></textarea></td>
                </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:5px;"></td>
          </tr>
          <tr>
            <td width="50%"><b><? echo _('Antwortformat').':'; ?></b></td>
            <td width="50%"><input type="button" class="button" onClick="displaySymbolDescription(); return false;" name="descriptionSymbols" value="<? echo _('Beschreibung der Symbole'); ?>"></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:5px;"></td>
          </tr>
          <tr>
            <td colspan="2" width="100%">
              <table width="600" border="0" cellspacing="1" cellpadding="0">
                <tr>
                  <td valign="top" width="250">
                    <table width="250" border="0" cellspacing="1" cellpadding="0">
                      <tr>
                        <td width="100" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Zitatzeichen').':'; ?></td>
                        <td width="150" style="font-size:12px; font-weight:normal; font-style:none;"><input type="text" name="answerQuoteSymbol" value="<? echo $answerQuoteSymbol; ?>" style="width:30px;"></td>
                      </tr>
                      <tr>
                        <td width="100" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Betreffprefix').':'; ?></td>
                        <td width="150" style="font-size:12px; font-weight:normal; font-style:none;"><input type="text" name="answerPrefix" value="<? echo $answerPrefix; ?>" style="width:30px;"></td>
                      </tr>
                    </table>
                  </td>
                  <td valign="top" width="350">
                    <textarea rows=15 cols=64 wrap="soft" style="width:353px; height: 70px;" name="answerQuoteString">
<? echo $answerQuoteString; ?></textarea>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:5px;"></td>
          </tr>
          <tr>
            <td width="50%"><b><? echo _('Weiterleitungsformat').':'; ?></b></td>
            <td width="50%"><input type="button" class="button" onClick="displaySymbolDescription(); return false;" name="descriptionSymbols" value="<? echo _('Beschreibung der Symbole'); ?>"></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:5px;"></td>
          </tr>
          <tr>
            <td colspan="2" width="100%">
              <table width="600" border="0" cellspacing="1" cellpadding="0">
                <tr>
                  <td valign="top" width="250">
                    <table width="250" border="0" cellspacing="1" cellpadding="0">
                      <tr>
                        <td width="100" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Zitatzeichen').':'; ?></td>
                        <td width="150" style="font-size:12px; font-weight:normal; font-style:none;"><input type="text" name="forwardQuoteSymbol" value="<? echo $forwardQuoteSymbol; ?>" style="width:30px;"></td>
                      </tr>
                      <tr>
                        <td width="100" style="font-size:12px; font-weight:normal; font-style:none;"><? echo _('Betreffprefix').':'; ?></td>
                        <td width="150" style="font-size:12px; font-weight:normal; font-style:none;"><input type="text" name="forwardPrefix" value="<? echo $forwardPrefix; ?>" style="width:30px;"></td>
                      </tr>
                    </table>
                  <td valign="top" width="350">
                    <textarea rows=15 cols=64 wrap="soft" style="width:353px; height: 70px;" name="forwardQuoteString">
<? echo $forwardQuoteString; ?></textarea>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;"></td>
          </tr>
          <tr>
            <td width="300"><input type="submit" class="button" name="save" value="<? echo _('Speichern'); ?>"></td>
            <td width="300" align="right"><input type="submit" class="button" name="back" value="<? echo _('Abbrechen'); ?>"></td>
          </tr>
          <tr>
            <td colspan="2" width="100%" style="height:15px;">&nbsp;</td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
</div>
</form>
</body>
</html>
