<?
/*******************************************************************************
*    WMail 1.0. Webmail for PHP                                                *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

include_once("table.php");
include_once($authSystem);

class AddBook extends BaseList
{
  var $nick, $name, $email;

  function AddBook($id, $nick = '', $name = '', $email = '')
  {
    $this->id = $id;
    $this->className = 'addbook';
    $this->nick = $nick;
    $this->name = $name;
    $this->email = $email;
  }

  function checkDataFormDelete($formName, $tClass, $myid)
  {
    return true;
  }

  function checkDataForm($formName, $tClass)
  {
    return false;
  }

  function setDataForm($formName, $tClass)
  {
    $this->nick = $_REQUEST[$formName.'_field_nick'];
    $this->name = $_REQUEST[$formName.'_field_name'];
    $this->email = strtolower($_REQUEST[$formName.'_field_email']);
  }

  function display($startTemplate, $endTemplate, $widths = array())
  {
    if(count($widths) == 1)
    {
      $span = '<span alt="'.$this->name.' <'.$this->email.'>" title="'.$this->name.' <'.$this->email.'>">';
      $stTem = str_replace('>', ' style="text-align:left;border-left-width:0px;border-right-width:0px;border-bottom-width:0px;border-top-width:0px;">', $startTemplate);
      $stTem = str_replace('%%WIDTH%%', $widths[0], $stTem);
      $nick = str_replace(' ', '_', $this->nick);
      print "$stTem$span<input id=\"addr_$nick\" type=\"CheckBox\" name=\"selAddBook[]\" value=\"".$this->nick."\"> <label for=\"addr_$nick\">".htmlentities($this->nick)."</label></span>$endTemplate\n";
    }
    else
    {
      $href = '<a class="addbook" href="compose.php?sid='.session_id().'&action=new&sendTo='.urlencode($this->nick).'" alt="'.sprintf(_('E-Mail f&uuml;r %s verfassen'), $this->nick).'" title="'.sprintf(_('E-Mail f&uuml;r %s verfassen'), $this->nick).'">';
      $vcard = '<a class="addbook" href="vcard.php?sid='.session_id().'&id='.$this->id().'" alt="'.sprintf(_('Daten von %s als vCard herunterladen'), $this->nick).'" title="'.sprintf(_('Daten von %s als vCard herunterladen'), $this->nick).'">';
      $stTem = str_replace('>', ' style="border-left-width:0px;border-right-width:0px;border-bottom-width:0px;border-top-width:0px;">', $startTemplate);
      $stTem = str_replace('%%WIDTH%%', $widths[0], $stTem);
      print "$stTem$href<img src=\"/images/compose.png\" border=\"0\"></a>$endTemplate\n";
      print "$stTem$vcard<img src=\"/images/vcard.png\" border=\"0\"></a>$endTemplate\n";
      $href = '<a class="addbook" href="addbook.php?sid='.session_id().'&editab='.$this->id().'">';
      $stTem = str_replace('>', ' style="border-right-width:0px;border-bottom-width:0px;border-top-width:0px;">', $startTemplate);
      $stTem = str_replace('%%WIDTH%%', $widths[1], $stTem);
      print "$stTem$href".htmlentities($this->nick)."</a>$endTemplate\n";
      $stTem = str_replace('>', ' style="border-right-width:0px;border-bottom-width:0px;border-top-width:0px;">', $startTemplate);
      $stTem = str_replace('%%WIDTH%%', $widths[2], $stTem);
      print "$stTem$href".htmlentities($this->name)."</a>$endTemplate\n";
      $stTem = str_replace('>', ' style="border-right-width:0px;border-bottom-width:0px;border-top-width:0px;">', $startTemplate);
      $stTem = str_replace('%%WIDTH%%', $widths[3], $stTem);
      print "$stTem$href".htmlentities($this->email)."</a>$endTemplate\n";
    }
  }

  function getFields()
  {
    return array($this->nick, $this->name, $this->email, '');
  }

  function fields()
  {
    return array('nick', 'name', 'email', 'compose');
  }

  function displayFieldsForEdit($formName, $field, $selected)
  {
  }
}
?>
