<?
/*******************************************************************************
*    WMail 1.0. Webmail for PHP                                                *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

include_once("table.php");
include_once("email.inc.php");
include_once($authSystem);

class Attachment extends BaseList
{
  var $ctype, $name, $size, $fname;

  function Attachment($id, $ctype = '', $name = '', $size = '', $fname = '')
  {
    $this->id = $id;
    $this->className = 'attachment';
    $this->ctype = $ctype;
    $this->name = $name;
    $this->size = $size;
    $this->fname = $fname;
  }

  function checkDataFormDelete($formName, $tClass, $myid)
  {
    foreach($tClass->lines as $line)
      if($line->id == $myid)
        return unlink($line->fname);

    return false;
  }

  function checkDataForm($formName, $tClass)
  {
    if($_FILES[$formName.'_field_name']['name'] != '')
      return true;
    return false;
  }

  function setDataForm($formName, $tClass)
  {
    global $tmpDir;

    $this->ctype = $_FILES[$formName.'_field_name']['type'];
    $this->size = $_FILES[$formName.'_field_name']['size'];
    $this->name = $_FILES[$formName.'_field_name']['name'];
    $this->fname = tempnam($tmpDir, "wmail_upload");
    move_uploaded_file($_FILES[$formName.'_field_name']['tmp_name'], $this->fname);
  }

  function display($startTemplate, $endTemplate, $widths = array())
  {
    $size = $this->size;
    if($size > 1048576)
      $sizeStr    = round($size / 1048576, 2)." Mb";
    else
      if($size > 1024)
        $sizeStr    = round($size / 1024, 2)." Kb";
      else
        $sizeStr    = "$size bytes";
    $span = '<span alt="'.$this->name.' ['.$this->ctype.'] - '.$sizeStr.'" title="'.$this->name.' ['.$this->ctype.'] - '.$sizeStr.'">';
    $stTem = str_replace('>', ' style="border-left-width:0px;border-right-width:0px;border-bottom-width:0px;border-top-width:0px;">', $startTemplate);
    $stTem = str_replace('%%WIDTH%%', $widths[0], $stTem);
    print "$stTem$span".htmlentities($this->name)."</span>$endTemplate\n";
  }

  function getFields()
  {
    return array($this->ctype, $this->name, $this->size);
  }

  function fields()
  {
    return array('name');
  }

  function displayFieldsForEdit($formName, $field, $selected)
  {
    if($field == 'name')
      print "<INPUT TYPE=\"File\" CLASS=\"button\" STYLE=\"width:550px;height:18px;\" NAME=\"$formName"."_field_$field\" VALUE=\"$selected\">";
  }
}
?>
