<?
/*******************************************************************************
*    WMail 1.0. Webmail for PHP                                                *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

include_once 'Net/POP3.php';
require_once 'Mail/mimeDecode.php';
require_once 'attachments.inc.php';

function readIndexMailBoxes($auth)
{
  $indexes = array();
  dbConnect();
  $pop3 =& new Net_POP3();
  foreach($auth->getAccounts() as $acc)
  {
    if($acc['Sent'] != '')
      $sentMails = array();
    $msgIds = array();
    $idxs = array();
    $nInbox = 0;
    $nSent = 0;
    $sentIds = array();
    $inboxIds = array();
    $pop3->connect($acc['POP3'], 110);
    $pop3->login($acc['POP3-User'], $acc['POP3-Pwd']);
    $indexes[$acc['Name'].'_nMsg'] = $pop3->numMsg();
    for($l = 1; $l <= $pop3->numMsg(); $l++)
    {
      $indexes[$acc['Name'].'_header_'.$l] = $pop3->getParsedHeaders($l);
//      $indexes[$acc['Name'].'_size_'.$l] = strlen($pop3->getMsg($l));
//      $indexes[$acc['Name'].'_hasAttachments_'.$l] = hasAttachments($pop3->getMsg($l));
// Now just read and compute the headers. It is faster... :)
      $listing = $pop3->getListing($l);
      $indexes[$acc['Name'].'_size_'.$l] = $listing['size'];
      $hs = $pop3->getParsedHeaders($l);
      if(strpos(strtolower($hs['Content-Type']), 'boundary') !== FALSE)
        $indexes[$acc['Name'].'_hasAttachments_'.$l] = 't';
      else
        $indexes[$acc['Name'].'_hasAttachments_'.$l] = 'f';

      $resent = 0;
      foreach(array_keys($indexes[$acc['Name'].'_header_'.$l]) as $h)
      {
        if(strtoupper($h) == 'RETURN-PATH')
        {
          $rp = $indexes[$acc['Name'].'_header_'.$l][$h];
          $rp = str_replace('<', '', $rp);
          $rp = str_replace('>', '', $rp);
        }
        if(strtoupper($h) == 'RESENT-FROM')
          $resent = 1;
        if(strtoupper($h) == 'FROM')
          $p1 = $indexes[$acc['Name'].'_header_'.$l][$h];
        if(strtoupper($h) == 'DELIVERY-DATE')
          $p2 = $indexes[$acc['Name'].'_header_'.$l][$h];
      }
      $p1 = str_replace('\\', '', $p1);
      $msgIds[$l] = $p1.'_'.$p2;
      if(strpos($p1, '<') != 0)
        $p1 = chop(substr($p1, strpos($p1, '<') + 1), '>');

      if($acc['Sent'] != '')
      {
        $mailIsSent = 0;
        foreach($auth->getAliases() as $p)
          if(strtolower($p['Aliasname']) == strtolower($rp))
            $mailIsSent = 1;
        if($resent == 1)
          $mailIsSent = 0;
        if($mailIsSent == 1)
        {
          $nSent++;
          array_push($sentMails, $msgIds[$l]);
          $sentIds[$msgIds[$l]] = $nSent;
        }
        else
        {
          $nInbox++;
          $inboxIds[$msgIds[$l]] = $nInbox;
        }
      }
      else
      {
        $nInbox++;
        $inboxIds[$msgIds[$l]] = $nInbox;
      }
    }
    $pop3->disconnect();
    $res = mysql_query("SELECT id FROM indexes WHERE account = '".$acc['POP3-User']."'");
    while($idx = mysql_fetch_array($res))
      array_push($idxs, $idx[0]);
    $l = 0;
    foreach($msgIds as $id)
    {
      $l++;
      if(!in_array($id, $idxs))
        if(in_array($id, $sentMails))
          mysql_query("INSERT INTO indexes (account, id, sent, nmsg, tmsg) VALUES('".$acc['POP3-User']."', '".mysql_escape_string($id)."', 't', $sentIds[$id], $l)");
        else
          mysql_query("INSERT INTO indexes (account, id, nmsg, tmsg) VALUES('".$acc['POP3-User']."', '".mysql_escape_string($id)."', $inboxIds[$id], $l)");
    }
    foreach($idxs as $id)
    {
      if(!in_array($id, $msgIds))
        mysql_query("DELETE FROM indexes WHERE account = '".$acc['POP3-User']."' AND id = '".mysql_escape_string($id)."'");
    }
  }
  dbDisconnect();
  return $indexes;
}

function readMail($acc, $nMsg)
{
  $mail = array();
  $pop3 =& new Net_POP3();

  $pop3->connect($acc['POP3'], 110);
  $pop3->login($acc['POP3-User'], $acc['POP3-Pwd']);
  $mail['Headers'] = $pop3->getParsedHeaders($nMsg);
  $decoder = new Mail_mimeDecode($pop3->getMsg($nMsg));
  $params['include_bodies'] = true;
  $params['decode_bodies']  = true;
  $params['decode_headers'] = true;
  $mail['Body'] = $decoder->decode($params);
  $pop3->disconnect();

  return($mail);
}

function decodeHeader($header, $noHeader = '__________________')
{
  if($header == '')
    return $noHeader;

  $ret = '';
  if(is_array($header))
    $hs = imap_mime_header_decode($header[0]);
  else
    $hs = imap_mime_header_decode($header);
  foreach($hs as $h)
    $ret .= $h->text;
  return $ret;
}

function decodePriority($priority)
{
  if(substr($priority, 0, 1) == '1' || substr($priority, 0, 1) == '2')
    return '<img src="/images/priority-high.png" alt="'._('Priorit&auml;t hoch').'" title="'._('Priorit&auml;t hoch').'">';
  if(substr($priority, 0, 1) == '4' || substr($priority, 0, 1) == '5')
    return '<img src="/images/priority-low.png" alt="'._('Priorit&auml;t niedrig').'" title="'._('Priorit&auml;t niedrig').'">';
}

function encodePriority($priority)
{
  switch($priority)
  {
    case 1:
      return array('XPRIORITY' => '1 (Highest)', 'IMPORTANCE' => 'high');
    case 2:
      return array('XPRIORITY' => '2 (High)', 'IMPORTANCE' => 'high');
    case 3:
      return array('XPRIORITY' => '3 (Normal)', 'IMPORTANCE' => 'normal');
    case 4:
      return array('XPRIORITY' => '4 (Low)', 'IMPORTANCE' => 'low');
    case 5:
      return array('XPRIORITY' => '5 (Lowest)', 'IMPORTANCE' => 'low');
  }
}

function hasAttachments($body)
{
  $hasAttach = 'f';

  $decoder = new Mail_mimeDecode($body);
  $params['include_bodies'] = true;
  $params['decode_bodies']  = true;
  $params['decode_headers'] = true;
  $mailBody = $decoder->decode($params);

  if(strcasecmp($mailBody->ctype_primary, 'multipart') == 0)
    foreach($mailBody->parts as $part)
      if((strcasecmp($part->disposition, 'attachment') == 0) || (strcasecmp($part->ctype_primary, 'text') != 0 && strcasecmp($part->ctype_primary, 'multipart') != 0))
        $hasAttach = 't';

  return $hasAttach;
}

function getBody($part)
{
  if($part->ctype_secondary == 'html')
    return strip_tags($part->body);
  else
  {
    if(ini_get('default_charset') != '')
      $fromCharset = ini_get('default_charset');
    else
      $fromCharset = 'iso-8859-15';
    if(isset($part->ctype_parameters) && !is_array($part->ctype_parameters))
      return wordwrap(iconv($part->ctype_parameters['charset'], $fromCharset, $part->body).' ', 80);
    else
      return wordwrap($part->body.' ', 80);
  }
}

function quoteMsg($rawMsg, $quoteSymbol)
{
  $quotedMsg = '';
  $quoteSymbol = chop($quoteSymbol);
  foreach(explode("\n", wordwrap($rawMsg, 80 - (strlen($quoteSymbol) + 1))) as $line)
    $quotedMsg .= "$quoteSymbol $line\n";
  return $quotedMsg;
}

function generateMessageBody($mailBody, $quoteSymbol, $quoteString, $saveAttachments, $htmlAsAttachment)
{
  $rawMsg = '';
  $attachments = array();
  if($mailBody->ctype_primary == 'multipart')
  {
    foreach($mailBody->parts as $part)
    {
      if($part->disposition != 'attachment')
      {
        if($part->ctype_primary == 'multipart')
        {
          foreach($part->parts as $p1)
          {
            if(strcasecmp($p1->ctype_secondary, 'plain') == 0)
              $rawMsg .= getBody($p1);
            if(strcasecmp($p1->ctype_secondary, 'html') == 0 && $htmlAsAttachment == 't')
            {
              $tmpfname = tempnam($tmpDir, "wmail_upload");
              $fp = fopen($tmpfname, "wb");
              fwrite($fp, $p1->body);
              fclose($fp);
              $att = new Attachment(count($attachments) + 1, $p1->ctype_primary.'/'.$p1->ctype_secondary, _('HTML-Nachricht'), strlen($p1->body), $tmpfname);
              array_push($attachments, $att);
            }
          }
        }
        else
        {
          if(strcasecmp($part->ctype_secondary, 'plain') == 0)
            $rawMsg .= getBody($part);
          if(strcasecmp($p1->ctype_secondary, 'html') == 0 && $htmlAsAttachment == 't')
          {
            $tmpfname = tempnam($tmpDir, "wmail_upload");
            $fp = fopen($tmpfname, "wb");
            fwrite($fp, $p1->body);
            fclose($fp);
            $att = new Attachment(count($attachments) + 1, $p1->ctype_primary.'/'.$p1->ctype_secondary, _('HTML-Nachricht'), strlen($p1->body), $tmpfname);
            array_push($attachments, $att);
          }
        }
      }
      else
      {
        if($saveAttachments == 1)
        {
          $tmpfname = tempnam($tmpDir, "wmail_upload");
          $fp = fopen($tmpfname, "wb");
          fwrite($fp, $part->body);
          fclose($fp);
          $att = new Attachment(count($attachments) + 1, $part->ctype_primary.'/'.$part->ctype_secondary, $part->d_parameters['filename'], strlen($part->body), $tmpfname);
          array_push($attachments, $att);
        }
      }
    }
  }
  else
    $rawMsg .= getBody($mailBody);

  $retMsg = $quoteString;
  $fromAddr = $mailBody->headers['from'];
    if(strpos($fromAddr, '(by way of ') != 0)
      $fromAddr = substr($fromAddr, 0, strpos($fromAddr, '(by way of ') - 1);

  $retMsg = str_replace('%d', $mailBody->headers['date'], $retMsg);
  $retMsg = str_replace('%f', $fromAddr, $retMsg);
  $retMsg = str_replace('%t', $mailBody->headers['to'], $retMsg);
  $retMsg = str_replace('%c', $mailBody->headers['cc'], $retMsg);
  $retMsg = str_replace('%s', $mailBody->headers['subject'], $retMsg);
  $retMsg = str_replace('\%', '%', $retMsg);
  $retMsg = str_replace('%m', $rawMsg, $retMsg);
  if(strpos($quoteString, '%Q') != 0)
    $retMsg = str_replace('%Q', quoteMsg($rawMsg, $quoteSymbol), $retMsg);

  return array('BODY' => $retMsg, 'ATTACHMENTS' => $attachments);
}

function terseSubject($prefix, $subject)
{
  while(substr($subject, 0, strlen($prefix) + 1) == $prefix.':')
    $subject = ltrim(substr($subject, strlen($prefix) + 1));
  return($subject);
}
?>
